(defun k_purge_list (liste / dummy_list ent)
;;; Dopelte eintrge aus Liste entfernen
  (foreach ent liste
    (if	(not (member ent dummy_list))
      (setq dummy_list (cons ent dummy_list))
    )
  )
  (reverse dummy_list)
)

(defun k_check-visible (obj / obj_name ent_name vis hide)
;;;  prft die Sichtbarkeit
;;;  0 = sichtbar und sichtbares Attribut
;;;  1 = sichtbar und unsichtbares Attribut
;;;  2 = unsichtbar und sichtbares Attribut
;;;  3 = unsichtbar und unsichtbares Attribut
  (cond
    ((= (type obj) 'ENAME)
     (setq ent_name obj
	   obj_name (vlax-ename->vla-object obj)
     )
    )
    ((= (type obj) 'VLA-OBJECT)
     (setq obj_name obj
	   ent_name (vlax-vla-object->ename obj)
     )
    )
  )
  (setq vis (assoc 60 (entget ent_name)))
  (setq hide (assoc 70 (entget ent_name)))
  (if vis
    (setq vis (cdr vis))
    (setq vis 0)
  )
  (if hide
    (setq hide (logand (cdr hide) 1))
    (setq hide 0)
  )
  (cond
    ((and (= vis 0) (= hide 0))
;;; Obj. sichtbar, Att. sichtbar
     0
    )
    ((and (= vis 0) (= hide 1))
;;; Obj. sichtbar, Att. unsichtbar
     1
    )
    ((and (= vis 1) (= hide 0))
;;; Obj. unsichtbar, Att. sichtbar
     2
    )
    ((and (= vis 1) (= hide 1))
;;; Obj. unsichtbar, Att. unsichtbar
     3
    )
  )
)

(defun k_all_blks (blk_list)
;;;  aus Liste mit Objektnamen von Blcken, alle Objektmamen verschachtelter Blcke ermitteln und mit ursprnglicher Blockliste zusammen als Gesamtliste zurckgeben
  (append
    blk_list
    (apply
      'append
      (vl-remove
	nil
	(mapcar
	  '(lambda (blk / dummy_list)
	     (vlax-for obj_name
				(vla-item
				  (vla-get-blocks
				    (vla-get-activedocument
				      (vlax-get-acad-object)
				    )
				  )
				  (vla-get-name blk)
				)
	       (if (and	(= (vla-get-ObjectName obj_name)
			   "AcDbBlockReference"
			)
			(member (k_check-visible obj_name) hide_check)
		   )
		 (setq dummy_list (cons obj_name dummy_list))
	       )
	     )
	     (print dummy_list)
	     (if dummy_list
	       (k_all_blks dummy_list)
	       dummy_list
	     )
	   )
	  blk_list
	)
      )
    )
  )
)

(defun k_vl-stay (tag liste)
;;;  Liste mit Elementen zurckgeben die tag entsprechen
;;;  wie vl-remove, nur nicht dieElemente entfernen sondern zurckgeben
  (vl-remove-if-not '(lambda (item) (equal item tag)) liste)
)

(defun k_satz->entlist (satz)
  (if (= (type satz) 'PICKSET)
    (vl-remove-if-not
      '(lambda (dummy) (= (type dummy) 'ENAME))
      (mapcar 'cadr (ssnamex satz))
    )
  )
)

;;; Hauptprogramme

(defun c:att_out_dlg (/ ATT_OUT_ID OK_DLG)
;;;  Einstelldialog
  (defun end_att_out (wert)
    (setq ok_dlg wert)
;;; Einstellungen in Variableniste
    (if	(= ok_dlg 1)
      (setq att_out_pre
	     (list (list "bereich" (get_tile "bereich"))
		   (list "ow" (get_tile "ow"))
		   (list "if-att" (get_tile "if-att"))
		   (list "hide-att" (get_tile "hide-att"))
		   (list "hide-obj" (get_tile "hide-obj"))
		   (list "stack-blk" (get_tile "stack-blk"))
		   (list "collect-blk" (get_tile "collect-blk"))
		   (list "dateiname" (get_tile "dateiname"))
		   (list "dateiname-name" (get_tile "dateiname-name"))
	     )
      )
    )
    (done_dialog)
  )

  (setq att_out_id (load_dialog "att_out.dcl"))
  (if (not (new_dialog "att_out" att_out_id))
    (exit)
  )
;;; Einstellungen aus Variableniste
  (if (not att_out_pre)
    (setq att_out_pre
	   '(("bereich" "bereich-Model")
	     ("ow" "ow-objektwahl")
	     ("if-att" "1")
	     ("hide-att" "0")
	     ("hide-obj" "0")
	     ("stack-blk" "1")
	     ("collect-blk" "1")
	     ("dateiname" "dateiname-fix")
	     ("dateiname-name" "att_out")
	    )
    )
  )
  (foreach pre att_out_pre
    (set_tile (car pre) (cadr pre))
  )
  (action_tile "accept" "(end_att_out 1)")
  (action_tile "cancel" "(end_att_out 0)")
  (start_dialog)
  (unload_dialog att_out_id)
  (if (= ok_dlg 1)
    (c:att_out)
  )
)

(defun c:att_out (/	       BEREICH	    BEREICH_CHECK
		  COLLECT-BLK  DATA	    DATA_LIST	 DATEINAME
		  DATEINAME-NAME	    DUMMY	 FILE
		  HANDLE_LIST  HIDE-ATT	    HIDE-OBJ	 HIDE_CHECK
		  IF-ATT       MENGE	    OBJ		 OBJ-ANZ_LIST
		  OBJ_LIST     OBJ_NAME	    OW		 PFAD
		  SPALTE       SPALTEN_LIST STACK-BLK	 TXT
		  ZEILEN_LIST
		 )

  (vl-load-com)
;;; Einstellungen aus Variableniste
  (if (not att_out_pre)
    (setq att_out_pre
	   '(("bereich" "bereich-Model")
	     ("ow" "ow-objektwahl")
	     ("if-att" "1")
	     ("hide-att" "0")
	     ("hide-obj" "0")
	     ("stack-blk" "1")
	     ("collect-blk" "1")
	     ("dateiname" "dateiname-fix")
	     ("dateiname-name" "att_out")
	    )
    )
  )
  (foreach pre att_out_pre
    (set (read (car pre)) (cadr pre))
  )
;;; Einstellungen auswerten
  (setq	hide_check
	 (cond
	   ((and (= hide-obj "0") (= hide-att "0"))
	    '(0)
	   )
	   ((and (= hide-obj "0") (= hide-att "1"))
	    '(0 1)
	   )
	   ((and (= hide-obj "1") (= hide-att "0"))
	    '(0 2)
	   )
	   ((and (= hide-obj "1") (= hide-att "1"))
	    '(0 3)
	   )
	 )
  )
  (setq	bereich_check
	 (cond
	   ((= bereich "bereich-Model")
	    "Model"
	   )
	   ((= bereich "bereich-alle")
	    "*"
	   )
	 )
  )

;;;  Objekte whlen oder alle, verschachtelt ja/nein
  (cond
    ((and (= ow "ow-objektwahl") (= stack-blk "0"))
     (setq
       obj_list	(mapcar
		  'vlax-ename->vla-object
		  (k_satz->entlist
		    (ssget
		      (list '(0 . "INSERT") (cons 410 bereich_check))
		    )
		  )
		)
     )
    )
    ((and (= ow "ow-objektwahl") (= stack-blk "1"))
     (setq
       obj_list
	(k_all_blks
	  (mapcar
	    'vlax-ename->vla-object
	    (k_satz->entlist
	      (ssget
		(list '(0 . "INSERT") (cons 410 bereich_check))
	      )
	    )
	  )
	)
     )
    )
    ((and (= ow "ow-alle") (= stack-blk "0"))
     (setq
       obj_list
	(mapcar
	  'vlax-ename->vla-object
	  (k_satz->entlist
	    (ssget "x" (list '(0 . "INSERT") (cons 410 bereich_check)))
	  )
	)
     )
    )
    ((and (= ow "ow-alle") (= stack-blk "1"))
     (setq
       obj_list
	(k_all_blks
	  (mapcar
	    'vlax-ename->vla-object
	    (k_satz->entlist
	      (ssget "x" (list '(0 . "INSERT") (cons 410 bereich_check)))
	    )
	  )
	)
     )
    )
  )

  (setq obj-anz_list nil)
;;;  Anzahl ermitteln
  (while obj_list
    (setq obj-anz_list
	   (cons (list (car obj_list)
		       (length (k_vl-stay (car obj_list) obj_list))
		 )
		 obj-anz_list
	   )
    )
    (setq obj_list (vl-remove (car obj_list) obj_list))
  )
;;; Datenliste erstellen
  (setq	data_list
	 (vl-remove
	   nil
	   (mapcar
	     '(lambda (data)
		(setq obj_name (car data))
		(if (and (= (vla-get-ObjectName obj_name)
			    "AcDbBlockReference"
			 )
			 (member (k_check-visible obj_name) hide_check)
		    )
		  (if
		    (and
		      (vlax-property-available-p
			obj_name
			"hasattributes"
		      )
		      (= (vla-get-hasattributes obj_name) :vlax-true)
		      (not (minusp (vlax-safearray-get-u-bound
				     (vlax-variant-value
				       (vla-getattributes obj_name)
				     )
				     1
				   )
			   )
		      )
		    )
		     (cons
		       (list (list "Handle" (vla-get-Handle obj_name))
			     (list "Menge" (itoa (cadr data)))
		       )
		       (list
			 (cons (list "Blockname" (vla-get-Name obj_name))
			       (vl-remove
				 'nil
				 (mapcar
				   '(lambda (obj)
				      (if
					(member (k_check-visible obj) '(0 1))
					 (list (vla-get-tagstring obj)
					       (vla-get-textstring obj)
					 )
				      )
				    )
				   (vlax-safearray->list
				     (vlax-variant-value
				       (vla-getattributes obj_name)
				     )
				   )
				 )
			       )
			 )
		       )
		     )
		     (if (= if-att "0")
		       (list (list "Handle" (vla-get-Handle obj_name))
			     (list "Blockname" (vla-get-Name obj_name))
			     (list "Menge" (itoa (cadr data)))
		       )
		     )
		  )
		)
	      )
	     obj-anz_list
	   )
	 )
  )

;;; Blockeinfgungen mit gleichen Daten zusamenfassen
  (if (= collect-blk "1")
    (setq data_list
	   (mapcar
	     '(lambda (data / handle_list menge)
		(setq menge 0)
		(foreach dummy
			       (vl-remove-if-not
				 '(lambda (check) (equal (cadr check) data))
				 data_list
			       )
		  (setq	handle_list
				    (cons (cadr (assoc "Handle" (car dummy)))
					  handle_list
				    )
			menge	    (+ menge
				       (atoi (cadr (assoc "Menge" (car dummy))))
				    )
		  )
		)
		(if (= (length handle_list) 1)
		  (setq handle_list (car handle_list))
		  (setq handle_list (vl-princ-to-string handle_list))
		)
		(append	(list (list "Handle" handle_list)
			      (list "Menge" (itoa menge))
			)
			data
		)
	      )
	     (k_purge_list (mapcar 'cadr data_list))
	   )
    )
    (setq data_list
	   (mapcar '(lambda (data) (apply 'append data)) data_list)
    )
  )

;;; Datei erstellen
  (if data_list
    (progn
      (setq spalten_list
			 (k_purge_list
			   (mapcar 'car (apply 'append data_list))
			 )
	    zeilen_list
			 (mapcar
			   '(lambda (data)
			      (subst ""
				     nil
				     (mapcar '(lambda (spalte)
						(cadr (assoc spalte data))
					      )
					     spalten_list
				     )
			      )
			    )
			   data_list
			 )
	    zeilen_list	 (cons spalten_list zeilen_list)
      )
      (cond
	((= dateiname "dateiname-fix")
	 (setq pfad (strcat (getvar "dwgprefix") dateiname-name ".txt"))
	)
	((= dateiname "dateiname-zeichnung")
	 (setq pfad (strcat (getvar "dwgprefix")
			    (vl-filename-base (getvar "dwgname"))
			    ".txt"
		    )
	 )
	)
	((= dateiname "dateiname-frei")
	 (setq
	   pfad
	    (getfiled "Liste speichern"
		      (strcat (getvar "dwgprefix")
			      (vl-filename-base (getvar "dwgname"))
			      "_att.txt"
		      )
		      "txt"
		      3
	    )
	 )
	)
      )
      (if pfad
	(progn
	  (setq file (open pfad "w"))
	  (foreach zeile zeilen_list
	    (write-line
	      (substr
		(apply
		  'strcat
		  (mapcar '(lambda (txt) (strcat "\t'" txt)) zeile)
		)
		2
	      )
	      file
	    )
	  )
	  (close file)
	)
      )
    )
  )
  (princ)
)

(defun c:att_in	(/	     DAT	 DATA	     DATA_LIST
		 DATEINAME   FILE	 HANDLE_LIST NAME
		 OBJ	     OBJ_NAME	 PFAD	     SPALTEN_LIST
		 SPALTEN_TXT ZEILE	 ZEILEN_LIST
		)
  (defun txt->list (txt z / C_LIST TXT_LIST)
;;; Zeichenkette zerlegen
    (foreach c (vl-string->list txt)
      (if (= c (ascii z))
	(setq txt_list
	       (cons (vl-list->string (reverse c_list)) txt_list)
	      c_list nil
	)
	(setq c_list (cons c c_list))
      )
    )
    (setq txt_list
	   (cons (vl-list->string (reverse c_list)) txt_list)
    )
    (setq txt_list (reverse txt_list))
  )

  (vl-load-com)
;;; Einstellungen aus Variableniste
  (if (not att_out_pre)
    (setq att_out_pre
	   '(("bereich" "bereich-Model")
	     ("ow" "ow-objektwahl")
	     ("if-att" "1")
	     ("hide-att" "0")
	     ("hide-obj" "0")
	     ("stack-blk" "1")
	     ("collect-blk" "1")
	     ("dateiname" "dateiname-fix")
	     ("dateiname-name" "att_out")
	    )
    )
  )
  (foreach pre att_out_pre
    (set (read (car pre)) (cadr pre))
  )
;;; Datei einlesen
  (cond
    ((= dateiname "dateiname-fix")
     (setq pfad (strcat (getvar "dwgprefix") name))
    )
    ((= dateiname "dateiname-zeichnung")
     (strcat (getvar "dwgprefix")
	     (vl-filename-base (getvar "dwgname"))
	     ".txt"
     )
    )
    ((= dateiname "dateiname-frei")
     (setq
       pfad
	(getfiled "Liste laden"
		  (strcat (getvar "dwgprefix")
			  (vl-filename-base (getvar "dwgname"))
			  "_att.txt"
		  )
		  "txt"
		  2
	)
     )
    )
  )

  (if pfad
    (progn
      (setq file (open pfad "r"))
      (while (setq zeile (read-line file))
	(setq zeilen_list (cons zeile zeilen_list))
      )
      (close file)
;;; Daten aufbeeiten
      (setq zeilen_list	 (reverse zeilen_list)
	    spalten_txt	 (car zeilen_list)
	    zeilen_list	 (cdr zeilen_list)
	    spalten_list (txt->list spalten_txt "\t")
	    data_list	 (mapcar
			   '(lambda (zeile)
			      (mapcar 'list
				      spalten_list
				      (txt->list zeile "\t")
			      )
			    )
			   zeilen_list
			 )
      )
;;; Datenliste erstellen
      (setq data_list
	     (mapcar
	       '(lambda	(data)
		  (mapcar '(lambda (dat)
			     (list (vl-string-left-trim "\'" (car dat))
				   (vl-string-left-trim "\'" (cadr dat))
			     )
			   )
			  data
		  )
		)
	       data_list
	     )
      )
;;; Daten in Objekte schreiben
      (foreach data data_list
;;;    zu bearbeitende Objekte ermitteln
	(setq handle_list
	       (cond
		 ((= (type (read (cadr (assoc "Handle" data)))) 'LIST)
		  (mapcar '(lambda (obj) (vl-princ-to-string obj))
			  (read (cadr (assoc "Handle" data)))
		  )
		 )
		 ((= (type (read (cadr (assoc "Handle" data)))) 'SYM)
		  (list (cadr (assoc "Handle" data)))
		 )
	       )
	)
;;;    abarbeiten
	(foreach handle	handle_list
	  (setq
	    obj_name (vla-handletoobject
		       (vla-get-activedocument (vlax-get-acad-object))
		       handle
		     )
	  )
	  (if (= (vla-get-ObjectName obj_name) "AcDbBlockReference")
	    (if
	      (and (vlax-property-available-p obj_name "hasattributes")
		   (= (vla-get-hasattributes obj_name) :vlax-true)
		   (not	(minusp	(vlax-safearray-get-u-bound
				  (vlax-variant-value
				    (vla-getattributes obj_name)
				  )
				  1
				)
			)
		   )
	      )
	       (foreach	obj (vlax-safearray->list
			      (vlax-variant-value
				(vla-getattributes obj_name)
			      )
			    )
		 (vla-put-textstring
		   obj
		   (cadr (assoc (vla-get-tagstring obj) data))
		 )
	       )
	    )
	  )
	)
      )
    )
  )
  (princ)
)
